/**
 * Addisu Petros
 * Vanshil Shah
 *
 */
#include "circ_buffer.h"

circular_buffer::circular_buffer() {
	for(int i = 0; i<MAX_SIZE; i++)
		buffer[i] = 0.0;
	cur_index = 0;
}

float circular_buffer::peek(int offset) {
	if(cur_index-offset < 0){
		return buffer[MAX_SIZE - offset];
	}
	else{
		return buffer[(cur_index) -offset];
	}
}

float circular_buffer::value_at(int offset) {
	float val;
	if(cur_index-offset < 0){
		val=buffer[MAX_SIZE - offset];
	}
	else{
		val = buffer[cur_index-offset];
	}
	cur_index++;
	if(cur_index == MAX_SIZE) {
		cur_index = 0;
	}

	return val;
}

void circular_buffer::set_value(int value) {
	buffer[(cur_index)] = value;
	cur_index++;
	if(cur_index == MAX_SIZE) {
		cur_index = 0;
	}
}

	// int circular_buffer::get_current(){
	// 	return cur_index;
	// }
// void circular_buffer::set_value_at_offset(int value, int offset){
// 	buffer[(cur_index)-offset] = value;
// }
